/******************************************************************************
 *
 *  Interrupt handler program test program
 *
 ******************************************************************************/
#ifdef __USAGE
%C [ -p priority ]

priority   = priority to run at (0 to 29) Default=10
#endif
 
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <sys/kernel.h>
#include <sys/vc.h>
#include <sys/seginfo.h>
#include <sys/osinfo.h>
#include <sys/name.h>
#include <i86.h>
#include <sys/irqinfo.h>
#include <sys/proxy.h>
#include <sys/sched.h>
#include <sys/timers.h>
#include <sys/name.h>
#include <fcntl.h>
#include <errno.h>
#include <string.h>

pid_t proxy;

volatile unsigned master_counter  = 0;
volatile unsigned process_counter = 0;

/* defaults */
int priority = 10;
unsigned c;

/* The hardware interrupt handler */
#pragma off( check_stack );
pid_t far handler()
{
    ++master_counter;

	printf("what???\n");

    return(proxy);
}
#pragma on( check_stack );


void main(argc,argv)
int argc;
char *argv[];
{
    int     c;
    int     ret;
    pid_t pid;
    int go = 1;
    int id;
	char *m;

    /* malloc a 64K region of memory and then free it ... so that our
       dataspace will not grow */
    
	m = (char *)malloc(64000);
    if ( m )
       free(m);
    else {
       fprintf(stderr,"Cannot pregrow our data segment. Terminating..\n");
       exit(0);
       }

    /* defaults */
    while ( ( c = getopt( argc, argv, "p:" ) ) != -1 ) {
         switch(c) {
            case 'p' : priority = atoi(optarg);
                       if ( priority < 0 || priority > 29 ) {
                          fprintf(stderr,"Invalid priority. Defaulting to 10.\n");
                          priority = 10;
                          }
                       break;
            }
         }


    if ( setprio( getpid(), priority ) == -1 ) {
       fprintf(stderr,"Error setting priority. (%s)\n",strerror(errno));
       exit(-1);
       }

    if ( ( proxy = qnx_proxy_attach( 0,0,0,-1 ) ) == -1 ) {
       fprintf(stderr,"Unable to attach to a proxy. (%s)\n", strerror(errno));
       exit(-1);
       }

    /* attach to the int handler */
    if ( ( id = qnx_hint_attach( 0, &handler, FP_SEG( &master_counter ) ) ) == -1 ) {
       fprintf(stderr,"Unable to attach to interrupt. (%s)\n", strerror(errno));
       exit(-1);
       }

    while (go) {              
        pid = Receive( proxy, NULL, 0 );

        /* do some work at process time */

            dumb_calculate();

        /* now increment the process counter ... */
        if ( process_counter + 1 != master_counter ) {
           printf("we've gone out of sync: master=%u, process=%u\n",
                   master_counter, process_counter );
           fflush(stdout);
           }
        process_counter++;

        if ( master_counter >=32000 ) {
           printf("done.\n");
           exit(0);
           }
        }
}


dumb_calculate()
{
int a, b, c;

b=5;

/*
for ( a=0; a < 1000; a++ )
    b = a * a;
*/

c = b * b;
}

