
#include <stdio.h>
#include <stdlib.h>
#include <stddef.h>
#include <string.h>
#include <signal.h>
#include <time.h>
#include <unistd.h>
#include <fcntl.h>
#include <sys/kernel.h>
#include <sys/mman.h>
#include <sys/psinfo.h>
#include <sys/proc_msg.h>
#include <sys/osinfo.h>
#include <sys/inline.h>
#include "monitor.h"
#include "imon.h"


l64    *intrtab;
l64    *priotab;



int mprio = 28;
char      *name = SYSI_NAME;


void *
mkmem()
{
	int fd;
	struct sysinfo_directory  *dir;
	struct sysinfo_direntry   *de;
	struct sysinfo_prioload   *pdata;
	struct sysinfo_intrload   *idata;
	void                      *p;

	if ((fd=shm_open(name, O_RDWR|O_CREAT, 0644)) == -1) {
		return 0;
	}
	ltrunc(fd, __PAGESIZE, SEEK_SET);
	if ((p=mmap(0, __PAGESIZE, PROT_READ|PROT_WRITE, MAP_SHARED, fd, 0))
			 == MAP_FAILED) {
		perror("mmap failed");
		return 0;
	}
	dir = p;
	de = (void *)(dir+1);
	pdata = (void *)(de+2);
	idata = (void *)(pdata+1);

	dir->sysi_magic = SYSI_MAGIC;
	dir->diroffs    = sizeof *dir;
	dir->ndirs      = 2;

	de[0].dirlen    =  sizeof *de;
	de[0].dirtype   = SIT_PRIO_LOAD;
	de[0].dataoffs  = (char *)pdata - (char *)dir;
	de[0].datalen   = sizeof *pdata;

	de[1].dirlen    =  sizeof *de;
	de[1].dirtype   = SIT_INTR_LOAD;
	de[1].dataoffs  = (char *)idata - (char *)dir;
	de[1].datalen   = sizeof *idata;

	priotab = pdata->priotimes;
	intrtab = idata->intrtimes;
	return (void *)dir;
}


EvAp_done(int ecode)
{
	exit(0);
}

done()
{
	return -1; /*signals an exit*/
}

main(int argc, char *argv[])
{
	int i, n;
	ulong_t          irqmask = 0;
	int              type = _MON_AUTO;

	while ((n = getopt(argc, argv, "85p:i:n")) != -1) {
		switch(n) {
		case '8':
			type = _MON_8254;
			break;
		case '5':
			type = _MON_RDTSC;
			break;
		case 'p':
			mprio = strtol(optarg, 0, 0);
			break;

		case 'i':
			i = strtol(optarg, 0, 0);
			irqmask |= _PROC_LOG_IRQ(i);
			break;

		case 'n':
			irqmask = -1;
			break;


		default:
			exit( EXIT_FAILURE );
		}
	}
	if (mkmem() == 0) {
		exit(1);
	}

	setprio(0, mprio);

	moninstall(type, 0);
	monsignal(SIGINT, done);
	monsignal(SIGTERM, done);
	monsignal(SIGQUIT, done);
	monsignal(SIGKILL, done);
	_evstart(getpid());
	ps_fill();
	time(0);
	qnx_kev_enable(-1, irqmask);
	printf("running\n");
	while (1) {
		sleep(1);
	}
	monshutdown();
}

