
#ifndef monitor_h
#define monitor_h

#include <sys/types.h>
#include <sys/osinfo.h>
#include <signal.h>
#include "kerevents.h"
#include "lmath.h"

#define _MON_AUTO  0
#define _MON_RDTSC 1
#define _MON_8254  2

extern char *moninstall(int type, sigset_t *block);
extern int   monsignal(int signo, int (*f)());
extern void  monshutdown(void);

extern struct _timesel far *montimep;
extern unsigned             monds;
extern struct _osinfo       monosdata;

extern qnx_kev_disable();
extern qnx_kev_enable(unsigned faults, unsigned irqset);



extern error(char *msg, ...);
extern chatter(char *msg, ...);

/*-
 * swint.asm echoes this structure; do not change
 */
#pragma pack(1)
struct KernelEvent {
	l64    timestamp;
	long   code;
	union {
		void __far       *datap;
		EventData __far  *eventp;
		unsigned long   data[2];
#define KE_OFF 0
#define KE_SEG 1
	}      ev;
};
#pragma pack()

extern struct KernelEvent monevent;

/*-
 * user supplies
 */
extern EvAp_put();
extern EvAp_done(int code); /*-tive for signal error*/

#endif
