/*-
 *  sys/wcc_kernel.h -- inline kernel calls for the watcom compiler.
 *
 *  Copyright by WATCOM International Corp. 1988-1993.  All rights reserved.
 *  Copyright by QNX Software Systems Limited 1990-1993. All rights reserved.
 */

#ifndef __WCC_KERNEL_H_INCLUDED
#define __WCC_KERNEL_H_INCLUDED

#ifndef __TYPES_H_INCLUDED
 #include <sys/types.h>
#endif

#ifndef __SENDMX_H_INCLUDED
 #include <sys/sendmx.h>
#endif

#ifndef __KERNEL_H_INCLUDED
 #include <sys/kernel.h>
#endif

#ifdef __cplusplus
extern "C" {
#endif
#pragma aux __sendmx =                   \
    "mov al,00h"                         \
    "clc"                                \
    "int 0f2h"                           \
    "jnc l1"                             \
    "call __kererr"                      \
    "l1:"                                \
    __parm [edx] [ah] [ch] [ebx] [esi]   \
    __modify __exact [eax]               \
    __value [eax]                        \
    ;
    
#pragma aux __receivemx =                \
    "mov al,01h"                         \
    "clc"                                \
    "int 0f2h"                           \
    "jnc l1"                             \
    "call __kererr"                      \
    "l1:"                                \
    __parm [edx] [ah] [ebx]              \
    __modify __exact [eax]               \
    __value [eax]                        \
    ;

#pragma aux __replymx =                  \
    "mov al,02h"                         \
    "clc"                                \
    "int 0f2h"                           \
    "jnc l1"                             \
    "call __kererr"                      \
    "l1:"                                \
    __parm [edx] [ah] [ebx]              \
    __modify __exact [eax]               \
    __value [eax]                        \
    ;

#pragma aux __creceivemx =               \
    "mov al,03h"                         \
    "clc"                                \
    "int 0f2h"                           \
    "jnc l1"                             \
    "call __kererr"                      \
    "l1:"                                \
    __parm [edx] [ah] [ebx]              \
    __modify __exact [eax]               \
    __value [eax]                        \
    ;

#pragma aux __readmsgmx =                \
    "mov al,04h"                         \
    "clc"                                \
    "int 0f2h"                           \
    "jnc l1"                             \
    "call __kererr"                      \
    "l1:"                                \
    __parm [edx] [ecx] [ah] [ebx]        \
    __modify __exact [eax]               \
    __value [eax]                        \
    ;

#pragma aux __writemsgmx =               \
    "mov al,05h"                         \
    "clc"                                \
    "int 0f2h"                           \
    "jnc l1"                             \
    "call __kererr"                      \
    "l1:"                                \
    __parm [edx] [ecx] [ah] [ebx]        \
    __modify __exact [eax]               \
    __value [eax]                        \
    ;

#pragma aux __relay =                    \
    "mov al,06h"                         \
    "clc"                                \
    "int 0f2h"                           \
    "jnc l1"                             \
    "call __kererr"                      \
    "l1:"                                \
    __parm [edx] [ebx]                   \
    __modify __exact [eax]               \
    __value [eax]                        \
    ;

#pragma aux __kill =                     \
    "mov eax,000eh"                      \
    "clc"                                \
    "int 0f2h"                           \
    "jnc l1"                             \
    "call __kererr"                      \
    "l1:"                                \
    __parm [edx] [ebx]                   \
    __modify __exact [eax]               \
    __value [eax]                        \
    ;

#pragma aux __sigsuspend =               \
    "mov eax,010eh"                      \
    "clc"                                \
    "int 0f2h"                           \
    "jnc l1"                             \
    "call __kererr"                      \
    "l1:"                                \
    __parm [edx]                         \
    __modify __exact [eax]               \
    __value [eax]                        \
    ;

#pragma aux __sret =                     \
    "mov al,07h"                         \
    "int 0f2h"                           \
    __modify __exact __nomemory []       \
    ;

#pragma aux __priority =                 \
    "mov al,08h"                         \
    "clc"                                \
    "int 0f2h"                           \
    "jnc l1"                             \
    "call __kererr"                      \
    "l1:"                                \
    __parm [edx] [ebx]                   \
    __modify __exact [eax]               \
    __value [eax]                        \
    ;

#pragma aux __netdata =                  \
    "mov al,09h"                         \
    "clc"                                \
    "int 0f2h"                           \
    "jnc l1"                             \
    "call __kererr"                      \
    "l1:"                                \
    __parm [edx] [ebx]                   \
    __modify __exact [eax]               \
    __value [eax]                        \
    ;

#pragma aux __yield =                    \
    "mov al,0ah"                         \
    "int 0f2h"                           \
    __modify __exact __nomemory [al]     \
    ;

#pragma aux __sendfdmx =                 \
    "mov al,0bh"                         \
    "clc"                                \
    "int 0f2h"                           \
    "jnc l1"                             \
    "call __kererr"                      \
    "l1:"                                \
    __parm [edx] [ah] [ch] [ebx] [esi]   \
    __modify __exact [eax]               \
    __value [eax]                        \
    ;

#pragma aux __trigger =                  \
    "mov al,0ch"                         \
    "clc"                                \
    "int 0f2h"                           \
    "jnc l1"                             \
    "call __kererr"                      \
    "l1:"                                \
    __parm [edx]                         \
    __modify __exact [eax]               \
    __value [eax]                        \
    ;

#pragma aux __semaphore =                \
    "mov eax,0010h"                      \
    "clc"                                \
    "int 0f2h"                           \
    "jnc l1"                             \
    "call __kererr"                      \
    "l1:"                                \
    __parm [edx] [ebx]                   \
    __modify __exact [eax]               \
    __value [eax]                        \
    ;

#ifdef __cplusplus
};
#endif

#endif
