/*-
 * ticks on machines without rdtsc insns...
 */

#include <sys/types.h>
#include <i86.h>
#include <sys/kev.h>
#include <sys/osinfo.h>
#include <sys/inline.h>
#include "monitor.h"
#include "monitor-private.h"

static unsigned TICKS_PER_IO = 4;

extern int LatchTimerAndReadIRR(unsigned lcmd);
#pragma aux LatchTimerAndReadIRR = \
	"mov    ah, al" \
	"mov	al, 0xa" \
	"out    0x20, al" \
	"mov    al, ah" \
	"out    0x43, al" \
	"in     al, 0x20" \
	"xor    ah, ah" \
	parm nomemory [eax] modify exact nomemory [eax] value [eax];

#define PIT_OUTSTAT(x)	 (((x)&0x80)!=0)
#define PIT_NULLCOUNT(x) (((x)&0x40)!=0)
#define PIT_MODE(x)      (((x)>>1)&07)
#define PIT_CMD(x)	 outb(0x43, x)
#define PIT_DATA()	 inb(0x40)

static
unsigned read8254(unsigned reloadcnt)
{
	register unsigned val;
	register uchar_t isintr, status, lo, hi;

	isintr = LatchTimerAndReadIRR(0xc2) & 01;
	status = PIT_DATA();
	lo   = PIT_DATA();
	hi   = PIT_DATA();
	val   = lo | hi<<8;
	switch (PIT_MODE(status)) {
	case 2: /* rate generator */
		if (val > TICKS_PER_IO) {
			val = reloadcnt - val;
			return isintr ? val+reloadcnt : val;
		}
		return val+reloadcnt;
	case 3: /* square wave generator */
		if (PIT_OUTSTAT(status)) {
			val = reloadcnt - (reloadcnt+val)/2 + (reloadcnt&01);
			return isintr ? val+reloadcnt:val;
		}
		if (val > TICKS_PER_IO*2) {
			return reloadcnt - val/2 + (reloadcnt&01);
		}
		return reloadcnt + val/2;
	}
	return 0;
}


void
montick_8254(void)
{
	register unsigned pcnt = read8254(montimep->cnt8254);
	monevent.timestamp[1] = montimep->cycle_hi;
	if ((monevent.timestamp[0] = montimep->cycle_lo+pcnt)<pcnt)
		monevent.timestamp[1]++;
}
