
#include <errno.h>
#include <string.h>
#include <sys/kernel.h>
#include <sys/proc_msg.h>

qnx_kev_disable()
{
	struct _proc_log_control lmsg;
	memset(&lmsg, 0, sizeof lmsg);
	lmsg.type = _PROC_LOG_CONTROL;
	lmsg.subtype = _PROC_SUB_ATTACH;
	Send(PROC_PID, &lmsg, &lmsg, sizeof lmsg, sizeof lmsg);
}

qnx_kev_enable(unsigned faults, unsigned irqset)
{
	struct _proc_log_control lmsg;
	int i;
	memset(&lmsg, 0, sizeof lmsg);
	lmsg.sw_mask = lmsg.sw_set = _PROC_LOG_KERNEL_CALLS;
	if (faults) {
		lmsg.sw_mask |= _PROC_LOG_FAULTS;
		lmsg.sw_set  |= _PROC_LOG_FAULTS;
	}
	lmsg.irq_mask = -1;
	if (irqset == -1) {
		for (i=-1; i <= 16; i++) {
			lmsg.irq_set  |= _PROC_LOG_IRQ(i);
		}
	} else {
		lmsg.irq_set  = irqset;
	}
	lmsg.type = _PROC_LOG_CONTROL;
	lmsg.subtype = _PROC_SUB_ATTACH;
	Send(PROC_PID, &lmsg, &lmsg, sizeof lmsg, sizeof lmsg);
}
