
#include <string.h>
#include <i86.h>
#include <sys/types.h>
#include <sys/kev.h>
#include <sys/psinfo.h>
#include <sys/inline.h>
#include <sys/proc_msg.h>
#include <sys/kernel.h>

#define _align(x,y) (((x)+(y)-1)&~((y)-1))

ps_event(pid_t pid, struct _psinfo *ps)
{
	struct _event_ker_proc_stat evdata;
	int len;
	evdata.pid		= pid;
	evdata.flags		= ps->flags;
	evdata.state		= ps->state;
	evdata.priority		= ps->priority;
	evdata.blocked_on	= ps->blocked_on;
	if(ps->flags & _PPF_VID) {
		evdata.un.vidinfo.remote_nid	= ps->un.vproc.remote_nid;
		evdata.un.vidinfo.remote_pid	= ps->un.vproc.remote_pid;
		evdata.un.vidinfo.local_pid	= ps->un.vproc.local_pid;
	} else if(ps->flags & _PPF_MID) {
		evdata.un.proxyinfo.count	= ps->un.mproc.count;
	} else {
		len = strlen(strcpy(evdata.un.pidinfo.name, ps->un.proc.name)) + 1;
	}
	_Kev(ECODE(_EVENT_KER_PROC_STAT, pid, 4), &evdata,
			_align(sizeof(evdata) - (100 - len),sizeof(long)));
	_Kev(ECODE(_EVENT_KER_PRIORITY, pid, 1), ps->priority);
}


ps_fill()
{
	struct _psinfo p;
	int    pi;

	for (pi=1 ; (pi=qnx_psinfo(PROC_PID, pi, &p, 0, 0)) != -1; pi++) {
		if (p.state == STATE_DEAD)
			continue;
		ps_event(p.pid, &p);
	}
}
