#include <string.h>
#include <sys/types.h>
#include <sys/psinfo.h>
#include <sys/kev.h>
#include "monitor.h"


#define _align(x,y) (((x)+(y)-1)&~((y)-1))
#define _offof(x,y) ((char *)&((x)->y) - (char *)(x))

int
psinfotopsevent(struct _psinfo *ps, struct _event_ker_proc_stat *evp)
{
	int len;

	evp->nid        = ps->sid_nid;
	evp->pid		= ps->pid;
	evp->flags		= ps->flags;
	evp->state		= ps->state;
	evp->priority	= ps->priority;
	evp->blocked_on	= ps->blocked_on;
	evp->pid_group  = ps->pid_group;
	evp->sid        = ps->sid;
	evp->sid_nid    = ps->sid_nid;

	if(ps->flags & _PPF_VID) {
		evp->un.vidinfo.remote_nid	= ps->un.vproc.remote_nid;
		evp->un.vidinfo.remote_pid	= ps->un.vproc.remote_pid;
		evp->un.vidinfo.local_pid	= ps->un.vproc.local_pid;
		len = _offof(evp, un) + sizeof evp->un.vidinfo;
	} else if(ps->flags & _PPF_MID) {
		evp->un.proxyinfo.count	= ps->un.mproc.count;
		len = _offof(evp, un) + sizeof evp->un.proxyinfo;
	} else {
		evp->un.pidinfo.father = ps->un.proc.father;
		evp->un.pidinfo.son    = ps->un.proc.son;
		evp->un.pidinfo.brother= ps->un.proc.brother;
		len = strlen(strcpy(evp->un.pidinfo.name, ps->un.proc.name)) + 1;
		len += _offof(evp, un) + _offof(&evp->un.pidinfo, name);
	}
	return _align(len,sizeof(long));
}
