#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <fcntl.h>
#include <unistd.h>

static FILE *msg_fp = 0;
static int ind_fd = -1;

int
msg_bldopen(char *file) {
	char *index;

	if ((index = malloc(strlen(file)+5)) == 0)
		return -1;
	sprintf(index, "%s.ind", file);
	if ((msg_fp = fopen(file, "r")) == 0) {
		free(index);
		return -1;
	}
	if ((ind_fd = open(index, O_WRONLY|O_CREAT|O_TRUNC, 0666)) == -1) {
		free(index);
		fclose(msg_fp);
		msg_fp = 0;
		return -1;
	}
	free(index);
	return 0;
}

void
msg_bldclose(void) {
	if (msg_fp) fclose(msg_fp);
	if (ind_fd != -1) close(ind_fd);
	msg_fp = 0;
	ind_fd = -1;
}

int
msg_bldindex(void) {
	char buf[200];
	msg_t type = -1;
	off_t offset = 0;

	if (!msg_fp || ind_fd == -1)
		return -1;
	while (fgets(buf, sizeof buf, msg_fp)) {
		msg_t ntype;

		if (*buf == '#') {
			offset = ftell(msg_fp);
			continue;
		}
		if ((ntype = strtol(buf, 0, 0)) != type) {
			if (lseek(ind_fd, ntype*sizeof(off_t), SEEK_SET) == -1)
				return -1;
			if (write(ind_fd, &offset, sizeof(off_t)) != sizeof(off_t))
				return -1;
			type = ntype;
		}
		offset = ftell(msg_fp);
	}
	return 0;
}
