/*-
 * KevIO: io package for Kev handling
 */
#include <string.h>
#include <stdlib.h>
#include "kevio.h"
#include "private.h"


KRec *
KevThis(KFILE *kp)
{
	return kp->currec;
}

KFilt *
KevAddFilt(KFILE *kp, int (*f)(), void *p)
{
	KFilt *nextp;
	KFilt *thisp;
	if (!kp)
		return 0;
	if ((thisp=calloc(sizeof *thisp, 0)) == 0)
		return 0;
	thisp->filt = f;
	thisp->arg = p;
	if (nextp=kp->filter) {
		while (nextp && nextp->next)
			nextp=nextp->next;
		nextp->next = thisp;
	} else {
		kp->filter = thisp;
	}
	return thisp;
}
