#include <stdio.h>
#include <stdlib.h>
#include <errno.h>
#include <string.h>
#include <ctype.h>

static char *
format_redir(char *p, void *msg, int *i) {
	int off, len;

	len = sizeof(int);
	if (*++p == '{') {
		off = strtol(++p, 0, 0);
		for (; *p && *p != ',' && *p != '}'; p++);
		if (*p == ',') {
			len = strtol(p+1, 0, 0);
			for (; *p && *p != '}'; p++);
			if (*p) p++;
		} else if (*p == '}')
			p++;
	} else {
		off = strtol(p, 0, 0);
		for (; *p && *p != ',' && *p != '}'; p++);
		if (*p == ',') p++;
	}
	switch (len) {
		case sizeof(int):
			*i = *(int *)((char *)msg+off);
			break;

		case sizeof(short):
			*i = *(short *)((char *)msg+off);
			break;
	}
	return p;
}

#define SKIP_FIELD(p) {for(; *p && *p != ',' && *p != '\n'; p++); if (*p) p++;}

char *
msg_symbolic_name(char *format) {
	static char ret[80];
	char *p, *r;

	if (format == 0)
		return "";
	p = format;
	/* skip "type,subtype," */
	SKIP_FIELD(p); SKIP_FIELD(p);
	if (*p == '\0')
		return format;
	for (r = ret; *p && *p != '\n' && *p != ',';) *r++ = *p++;
	*r = '\0';
	return ret;
}

char *
msg_fancy_format(char *format, char *msg, int msglen) {
	static char ret[200];
	static char *rp;
	char *p;

	p = format;
	/* skip "type,subtype,symbolic_name," */
	SKIP_FIELD(p); SKIP_FIELD(p); SKIP_FIELD(p);
	if (*p == '\n' || *p == '\0')
		return msg_symbolic_name(format);
	*ret = '\0';
	for (rp = ret; *p && *p != '\n';) {
		if (*p == '$' && *(p+1) == '{') {
			int off, len;
			char fmt[10], format[10];
			char *r = 0;

			p += 2;
			if (*p == '@')
				p = format_redir(p+1, msg, &off);
			else
				off = strtol(p, 0, 10);
			len = 1;
			for (; *p && *p != ',' && *p != '}'; p++);
			if (*p == ',') {

				p++;
				for (r = fmt; *p && *p != ',' && *p != '}';)
					*r++ = *p++;
				*r-- = '\0';
				if (*p == ',') {
					if (*(p+1) == '@')
						p = format_redir(p+2, msg, &len);
					else {
						len = strtol(++p, 0, 0);
						for (; *p && *p != '}'; p++);
					}
				}
			}
			if (*p) p++;
			if (!r || isdigit(*r))
				strcpy(format, "%d");
			else
				sprintf(format, "%%%c", *r);
			len = min(msglen - off, len);
			while (len-- > 0) {
				switch (*fmt) {
				case 'd':
				case 'x':
				case 'u':
				case '4':
					rp += sprintf(rp, format,
						*(int *)(msg+off));
					off += 4;
					break;

				case '2':
					rp += sprintf(rp, format,
						*(short *)(msg+off));
					off += 2;
					break;

				case '1':
					rp += sprintf(rp, format,
						*(char *)(msg+off));
					off += 1;
					break;

				case 's':
					{int i;

					i = sprintf(rp, format,
						(char *)(msg+off));
					rp += i;
					off += i + 1;
					}
					break;
				}
			}
			continue;
		}
		*rp++ = *p++;
	}
	*rp = '\0';
	return ret;
}
