
#include <libc.h>

struct nm {
	ulong_t       a;
	char          name[1];
};

struct nm **nlist;
unsigned       ntab;
unsigned       nlast;


int
nmcomp(struct nm **a, struct nm **b)
{
	return (*a)->a - (*b)->a;
}

int
nmadd(ulong_t a, char *name)
{
	struct nm *p = malloc(sizeof *p + strlen(name)-1);
	if (!p)
		return -1;
	p->a = a;
	strcpy(p->name, name);
	if (nlast >= ntab) {
		struct nm **p = realloc(nlist, (ntab+64)*sizeof *nlist);
		if (!p)
			return -1;
		nlist = p;
		ntab += 64;
	}
	nlist[nlast++] = p;
	return 0;
}

nmload(char *fn)
{
	FILE   *fp;
	char buf[256];
	if ((fp=fopen(fn, "r")) == 0) {
		return -1;
	}
	while (fgets(buf, sizeof buf-1, fp)) {
		ulong_t a;
		char   *n[3];
		if ((n[0]=strtok(buf, " \t\n")) &&
		    (n[1]=strtok(0, " \t\n")) &&
		    (n[2]=strtok(0, " \t\n")) &&
		    (strtol(n[2], 0, 16)& ~3) == 4) {
			nmadd(strtol(n[1], 0, 16), n[0]);
		}
	}
	qsort(nlist, nlast, sizeof *nlist, nmcomp);
	return 0;
}

/*-
 * rewrite as binary search
 */
char *
nlookup(ulong_t a)
{
	unsigned i;
	static char buf[20];
	for (i=0; i < nlast; i++) {
		if (nlist[i]->a <= a && (i+1 == nlast || nlist[i+1]->a > a))
			return nlist[i]->name;
	}
	sprintf(buf, "0x%x", a);
	return buf;
}
