
/*-
 * KevIO: io package for Kev handling
 */
#include <string.h>
#include <stdlib.h>
#include "kevio.h"
#include "private.h"


KFILE *
KevOpen(char *fn)
{
	FILE    *fp;
	if ((fp=fopen(fn, "r")) == 0)
		return 0;
	return KevFopen(fp);
}

KFILE *
KevFopen(FILE *fp)
{
	KFILE   *kp = calloc(sizeof *kp, 1);
	if (kp == 0)
		return 0;
	if ((kp->fp = fp) == 0) {
		KevClose(kp);
		return 0;
	}
	kp->currec = 0;
	if (fread(&kp->hdr, sizeof kp->hdr, 1, kp->fp) != 1) {
		KevClose(kp);
		return 0;
	}
	if (!KEV_ISMAG(kp->hdr.magic)) {
		KevClose(kp);
		return 0;
	}
	proc_init(kp);
	KevRewind(kp);
	return kp;
}


void
KevClose(KFILE *kp)
{
	if (kp->currec)
		free(kp->currec);
	if (kp->fp)
		fclose(kp->fp);
	free(kp);
}

void
KevRewind(KFILE *kp)
{
	fseek(kp->fp, kp->hdr.dataoffs, SEEK_SET);
	kp->recno = -1;
}

int
KevGetStat(KFILE *kf, KSTAT *ks)
{
	ks->cpu = kf->hdr.cpu;
	ks->samples = kf->hdr.nsamples;
	ks->tick_sec = kf->hdr.tick_per_sec;
	return 0;
}

