/*-
 * private definitions and functions for the kernel event library.
 *
 */

#ifndef private_h
#define private_h

#define KevMkCode(maj, min) EOPNO(maj,min)

#ifndef debug
#define debug 0
#endif

/*-
 * internal proc info.
 */
typedef struct IProc IProc;
struct IProc {
	unsigned        valid;
	Proc            p;
};

struct _KFilt {
	int      (*filt)();
	void      *arg;
	KFilt     *next;
};


struct _KFILE {
	FILE      *fp;
	struct kev_header hdr;
	ulong_t    pidhash;
	IProc     *proctab;
	long       recno;
	ulong_t    ktick;
	KRec      *currec;
	KFilt     *filter;
};

#define PID_INDEX(fp, pid)  (((pid) & (fp)->pidhash)+1)

/*-
 * these should have uglier names...
 */
extern int    __proc_init(KFILE *fp);
extern int    __proc_update(KFILE *fp, KRec *kr);
extern int    __proc_delete(KFILE *kfp, unsigned pid);
extern KRec * __kev_read(KFILE *kfp);

#define proc_init     __proc_init
#define proc_update   __proc_update
#define proc_delete   __proc_delete
#define kev_read      __kev_getevent

#endif
