#include <libc.h>
#include "kevio.h"


dumpdata(FILE *f)
{
	KFILE *k = KevFopen(f);
	KRec  *p;

	if (k == 0) {
		fprintf(stderr, "not a sample file\n");
		return -1;
	}
	while (p=KevNext(k)) {
		dumpev(p, stdout);
	}
	KevClose(k);
}

main(int argc, char **argv)
{
	int            i;
	while ((i=getopt(argc, argv, "")) != -1)
		;
	if (optind == argc) {
		dumpdata(stdin);
	} else for (i=optind; i < argc; i++) {
		FILE          *f;
		if (f=fopen(argv[i], "r")) {
			printf("%s:\n", argv[i]);
			dumpdata(f);
			fclose(f);
		} else {
			fprintf(stderr,"%s: unable to open '%s'\n",
				argv[0], argv[i]);
		}
	}
	return 0;
}
