#include <libc.h>

char         verbose = 0;

double       factor = 0.8380966;
double       orig = 0.0;

char *
cvt(char *bufp, double *oval)
{
	char    *p;
	ulong_t  x0, x1;

	x0 = strtoul(bufp, &p, 16);
	if (*p != '.') {
		return 0;
	}
	x1 = strtoul(p+1, &p, 16);

	*oval = ((double)x1 + ((double)UINT_MAX)+1)*factor;
	return p;
}

outl(double v, char *bufp)
{
	printf("%g: %s", v - orig, bufp);
}

outd(double v, char *bufp)
{
static double last;
static int    lset = 0;
	if (lset == 0)
		last = v;
	printf("%g: %s", v - last, bufp);
	last = v;
	lset = 1;
}


runt(FILE *fp, void out(double, char *))
{
	char         buf[2048];
	double       oval;
	char        *p;
	while (fgets(buf, sizeof buf-1, stdin) && (p=cvt(buf, &oval))== 0);

	orig = oval;
	
	do {
		out(oval, verbose ? buf : p);
	} while (fgets(buf, sizeof buf-1, stdin) && (p=cvt(buf, &oval)));
	return 0;
}

main(int argc, char **argv)
{
	void (*outf)(double, char *) = outl;
	int                c;
	while ((c=getopt(argc, argv, "f:dv")) != -1) {
		switch (c) {
		case 'f': factor = 1 / strtod(optarg,0);
		case 'd': outf = outd; break;
		case 'v': verbose = 1; break;
		}
	}
	runt(stdin, outf);
}
