#include <libc.h>
#include "kevio.h"


print(KRec *e)
{
static int nesting = 0;
	int	i;
#define NEST()	for(i=0; i < nesting; i++) putchar(' ')

	switch (e->kr_opcode) {
	case _EVENT_KER_IRQ:
		NEST();
		print_time(e, stdout);
		printf(" interrupt #%d: @%04.4x:%08.8lx ",
			(short)(e->kr_data[1]>>16),
			e->kr_data[1] & 0xffff,
			e->kr_data[0]);
		if (e->kr_oprnd) {
			printf("(pid %u) \n", e->kr_oprnd);
		} else {
			printf("(kernel) \n");
		}
		nesting++;
		break;

	case _EVENT_KER_IRQDONE:
		nesting--;
		NEST();
		print_time(e, stdout);
		printf(" end of interrupt #%d\n", e->kr_oprnd);
		break;

	case _EVENT_KER_USER_IRQ:
		NEST();
		putchar('>');
		print_time(e, stdout);
		printf(" interrupt handler(%d): pid %u, @%04.4x:%08.5lx\n",
			(short)(e->kr_data[1]>>16),
			e->kr_oprnd,
			e->kr_data[1] & 0xffff,
			e->kr_data[0]);
		break;

	case _EVENT_KER_USER_EOI:
		NEST();
		putchar('<');
		print_time(e, stdout);
		if (e->kr_oprnd) {
			printf(" handler done, wakeup %u\n", e->kr_oprnd);
		} else {
			printf(" handler done\n");
		}
		break;

	default:
		break;
	}
	return 0;
}

int
data_only(KRec *e)
{
	return (e->kr_opcode == _EVENT_KER_SEND ||
		e->kr_opcode == _EVENT_KER_REPLY);
}

printintr(FILE *f)
{
	KFILE *k = KevFopen(f);
	KRec  *p;
	if (k == 0) {
		fprintf(stderr, "not a sample file\n");
		return -1;
	}
#if 0
	KevAddFilt(k, data_only, 0);
#endif

	while (p=KevNext(k)) {
		print(p);
	}
	return 0;
}

main(int argc, char **argv)
{
	int            i;
	while ((i=getopt(argc, argv, "")) != -1)
		;
	if (optind == argc) {
		printintr(stdin);
	} else for (i=optind; i < argc; i++) {
		FILE          *f;
		if (f=fopen(argv[i], "r")) {
			printf("%s:\n", argv[i]);
			printintr(f);
			fclose(f);
		} else {
			fprintf(stderr,"%s: unable to open '%s'\n",
				argv[0], argv[i]);
		}
	}
	return 0;
}
