

/*-
 * dump - dump the text segment of a program.
 */

#include <libc.h>
#include "dbi.h"


int verbose = 0;

names(char *src)
{
	FILE      *fp;
	lmfo      *obj;
	symiter    it;
	gbl_info  *sym;

	if ((fp=fopen(src, "r")) == 0) {
		fprintf(stderr, "%s: cannot open\n", src);
		return -1;
	}

	if ((obj=lmf_open(fp)) == 0) {
		fclose(fp);
		return -1;
	}
	if (lmf_symiter(obj, &it) == -1) {
		lmf_close(obj);
		return -1;
	}	
	while (sym=lmf_symnext(&it)) {
		printf("%-32.32s %08.8lx %04.4lx\n",
			sym->name,
			sym->addr.offset,
			sym->addr.segment);
	}
	lmf_close(obj);
	return 0;
}


main(int argc, char **argv)
{
	int	c, i;

	while ((c=getopt(argc, argv, "v")) != -1) {
		switch (c) {
		case 'v': verbose = 1; break;
		}
	}
	for (i=optind; i < argc; i++) {
		if (names(argv[i]) == -1) {
			fprintf(stderr, "%s: couldn't dump %s\n", argv[0], argv[i]);
		}
	}
	return 0;
}
