
#include <libc.h>
#include "kevio.h"

showdata(FILE *f)
{
	KFILE *k = KevFopen(f);
	KSTAT kstat;
	KRec  *p;
unsigned events = 0;

	if (k == 0) {
		fprintf(stderr, "not a sample file\n");
		return -1;
	}
	if (KevGetStat(k, &kstat) == 0) {
		printf("%lu samples, cpu = u%l, %lu cycles per sec\n",
			kstat.samples, kstat.cpu, kstat.tick_sec);
	}
	while (p=KevNext(k)) {
		/*print_kerevent(k, p, stdout); */
		events++;
	}
printf("%u events\n", events);
	return 0;
}

main(int argc, char **argv)
{
	int            i;
	while ((i=getopt(argc, argv, "")) != -1)
		;
	if (optind == argc) {
		showdata(stdin);
	} else for (i=optind; i < argc; i++) {
		FILE          *f;
		if (f=fopen(argv[i], "r")) {
			showdata(f);
			fclose(f);
		} else {
			fprintf(stderr,"%s: unable to open '%s'\n",
				argv[0], argv[i]);
		}
	}
	return 0;
}
