
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/osinfo.h>
#include <sysinfo.h>
#include <unistd.h>

static double hz;
struct _osinfo o;

#define ul2d(ul)  (ul[_L64_LO] + ul[_L64_HI]*4294967296.0)


int accumulate;


static
pdiff(l64 from, l64 to, int prio, char *m)
{
	double a = ul2d(from);
	double b = ul2d(to);
	if (a!=b) {
		printf("%s%d +%f\n", m, prio, (b-a)/hz);
	}
}


typedef int (*pfi)();

struct sysinfo_prioload  *curprio, lastprio;
struct sysinfo_intrload  *curintr, lastintr;

runprio()
{
	int i;
	for (i=0; i < SYS_NPRIO; i++) {
		pdiff(lastprio.priotimes[i], curprio->priotimes[i], i, "prio");
		if (!accumulate)
			ul_copy(lastprio.priotimes[i], curprio->priotimes[i]);
	}
}

runintr()
{
	int i;
	for (i=0; i < SYS_NINTR; i++) {
		pdiff(lastintr.intrtimes[i], curintr->intrtimes[i], i, "intr");
		if (!accumulate)
			ul_copy(lastintr.intrtimes[i], curintr->intrtimes[i]);
	}
}



pfi
initprio(void *p)
{
	int i;
	curprio = p;
	for (i=0; i < SYS_NPRIO; i++) {
		if (accumulate) {
			ul_copy(lastprio.priotimes[i], curprio->priotimes[i]);
		} else {
			ul_make(lastprio.priotimes[i], 0, 0);
		}
	}
	return runprio;
}


pfi
initintr(void *p)
{
	int i;
	curintr = p;
	for (i=0; i < SYS_NINTR; i++) {
		if (accumulate) {
			ul_copy(lastintr.intrtimes[i], curintr->intrtimes[i]);
		} else {
			ul_make(lastintr.intrtimes[i], 0, 0);
		}
	}
	return runintr;
}


main(int argc, char **argv)
{
	SYSI_DIR      Dir;
	SYSI_DIRENT   De;
	pfi           flist[10];
	int           nf = 0;
	int           c;

	while ((c=getopt(argc, argv, "a")) != -1) {
		switch (c) {
		case 'a': accumulate = 1; break;
		}
	}
	qnx_osinfo(0, &o);
	hz = (o.cpu_features&0xfff)*1000000.0;

	if (sysi_diropen(SYSI_NAME, &Dir) != 0) {
		return 1;
	}
	while (sysi_readdir(&Dir, &De) == 0) {
		switch (De.type) {
		case SIT_PRIO_LOAD:
			if (flist[nf] = initprio(De.map)) {
				nf++;
			}
			break;
		case SIT_INTR_LOAD:
			if (flist[nf] = initintr(De.map)) {
				nf++;
			}
			break;
		default:
			break;
		}
	}
	while (nf) {
		int i;
		for (i=0; i < nf; i++) {
			(flist[i])();
		}
		sleep(1);
	}
	return 0;
}
