
/*
 *	faults.c
 *
 *	QNX
 *
 *	(C) Copyright 1991, 1992, 1996 by Robert Krten, all rights reserved.
 *
 *	This module is responsible for monitoring fault rates
 *
 *	1996 08 17	R. Krten		stole from interrupts.c, modified
*/

#include "sysmon.h"
#include <sys/proc_msg.h>

extern	char *progname;					/* main.c */
extern	char *version;					/* version.c */

static	void	faultMonitor (void);
static	void	totalfaults (void);

extern	int opta;
extern	int optims;
extern	struct _psinfo psData;
extern	char *lines;

static	struct _proc_counter_reply1 cnt [2];

void
doFAULTS ()
{
	if (getcounts (cnt) == -1) {		// prime, and verify
		fatal ("your machine doesn't support kernel events");
	}

	term_cur (1, 0);
	term_clear (TERM_CLS_EOS);
	term_printf (2, 28, opta, "CPU Faults");
	term_printf (4,  0, opta, "Ŀ");
	term_printf (5,  0, opta, " Fault    Counts   1 3 5 7  10   15   20   25   30   35   40   45   50   55");
	term_printf (6,  0, opta, "Ĵ");
	term_printf (7,  0, opta, "  0  /0   .......                                                          ");
	term_printf (8,  0, opta, "  1 DEBG  .......                                                          ");
	term_printf (9,  0, opta, "  2 NMI   .......                                                          ");
	term_printf (10, 0, opta, "  3 BRKP  .......                                                          ");
	term_printf (11, 0, opta, "  4 OVFL  .......                                                          ");
	term_printf (12, 0, opta, "  5 BNDC  .......                                                          ");
	term_printf (13, 0, opta, "  6 ILL   .......                                                          ");
	term_printf (14, 0, opta, "  7 NPD   .......                                                          ");
	term_printf (15, 0, opta, "  8 2FLT  .......                                                          ");
	term_printf (16, 0, opta, "  9 NDP2  .......                                                          ");
	term_printf (17, 0, opta, " 10 IVTS  .......                                                          ");
	term_printf (18, 0, opta, " 11 SGNP  .......                                                          ");
	term_printf (19, 0, opta, " 12 STCK  .......                                                          ");
	term_printf (20, 0, opta, " 13 GPF   .......                                                          ");
	term_printf (21, 0, opta, " 14 PAGE  .......                                                          ");
	term_printf (22, 0, opta, " 15 RSVD  .......                                                          ");
	term_printf (23, 0, opta, " 16 FPE   .......                                                          ");
	term_printf (24, 0, opta, "");
	term_flush ();
	
	for (;;) {
		faultMonitor ();
		delay (optims);

		if (dev_ischars (0) && getc (stdin) == 'q') {
			break;
		}
	}
}

static void
faultMonitor ()
{
	static int oddeven = 1;
	int		i;
	unsigned count;
	char	fmt [BUFSIZ];
	
	getcounts (cnt + oddeven);			// get the other buffer filled
	for (i = 0; i < 17; i++) {
		term_printf (i + 7, 12, opta, "%7u  ", count = cnt [oddeven].faults [i] - cnt [!oddeven].faults [i]);
		term_clear (TERM_CLS_EOL);
		sprintf (fmt, "%%%d.%ds", count, count);
		term_printf (7 + i, 22, opta, fmt, lines);
		term_printf (7 + i, 78, opta, "");
	}
	term_flush ();
	oddeven = !oddeven;
}

