
/*
 *	kcalls.c
 *
 *	QNX
 *
 *	(C) Copyright 1991, 1992, 1996 by Robert Krten, all rights reserved.
 *
 *	This module is responsible for monitoring kcall rates
 *
 *	1996 08 17	R. Krten		stole from interrupts.c, modified
*/

#include "sysmon.h"
#include <sys/proc_msg.h>

extern	char *progname;					/* main.c */
extern	char *version;					/* version.c */

static	void	kcallMonitor (void);

extern	int opta;
extern	int optims;
extern	struct _psinfo psData;
extern	char *lines;

extern	int log10Table [];

static	struct _proc_counter_reply1 cnt [2];

void
doKCALLS ()
{
	if (getcounts (cnt) == -1) {		// prime, and verify
		fatal ("your machine doesn't support kernel events");
	}

	term_cur (1, 0);
	term_clear (TERM_CLS_EOS);
	term_printf (2, 18, opta, "CPU kernel calls (Log scale)");
	term_printf (4,  0, opta, "Ŀ");
	term_printf (5,  0, opta, " KCall    Counts      10        100        1k        10k       100k      1M");
	term_printf (6,  0, opta, "Ĵ");
	term_printf (7,  0, opta, "  0 SEND  .......                                                          ");
	term_printf (8,  0, opta, "  1 RECV  .......                                                          ");
	term_printf (9,  0, opta, "  2 REPL  .......                                                          ");
	term_printf (10, 0, opta, "  3 CRCV  .......                                                          ");
	term_printf (11, 0, opta, "  4 RMSG  .......                                                          ");
	term_printf (12, 0, opta, "  5 WMSG  .......                                                          ");
	term_printf (13, 0, opta, "  6 RELY  .......                                                          ");
	term_printf (14, 0, opta, "  7 SRET  .......                                                          ");
	term_printf (15, 0, opta, "  8 PRIO  .......                                                          ");
	term_printf (16, 0, opta, "  9 NET   .......                                                          ");
	term_printf (17, 0, opta, " 10 YILD  .......                                                          ");
	term_printf (18, 0, opta, " 11 SNFD  .......                                                          ");
	term_printf (19, 0, opta, " 12 TRIG  .......                                                          ");
	term_printf (20, 0, opta, " 13 SPEC  .......                                                          ");
	term_printf (21, 0, opta, " 14 SIG   .......                                                          ");
	term_printf (22, 0, opta, " 15 APM   .......                                                          ");
	term_printf (23, 0, opta, " 16 SEMW  .......                                                          ");
	term_printf (24, 0, opta, "");
	term_flush ();
	
	for (;;) {
		kcallMonitor ();
		delay (optims);

		if (dev_ischars (0) && getc (stdin) == 'q') {
			break;
		}
	}
}

static void
kcallMonitor ()
{
	static int oddeven = 1;
	int		i;
	unsigned count;
	char	fmt [BUFSIZ];
	
	getcounts (cnt + oddeven);			// get the other buffer filled
	for (i = 0; i < 17; i++) {
		term_printf (i + 7, 12, opta, "%7u  ", count = cnt [oddeven].kcalls [i] - cnt [!oddeven].kcalls [i]);
		term_clear (TERM_CLS_EOL);
		if (count) {
			count = convertToLog (count);
			if (count > 7) {
				count -= 7;
			} else {
				count = 1;
			}
			sprintf (fmt, "%%%d.%ds", count, count);
			term_printf (7 + i, 22, opta, fmt, lines);
		}
		term_printf (7 + i, 78, opta, "");
	}
	term_flush ();
	oddeven = !oddeven;
}

