
/*
 *	regs.c
 *
 *	QNX 4
 *
 *	(C) Copyright 1991, 1992 by Robert Krten, all rights reserved.
 *
 *	1991 09 23	R. Krten		created
 *	1992 01 05	R. Krten		released for free
*/

#include "sysmon.h"

#include "sys/debug.h"

struct _psinfo psData;
struct _osinfo osData;
struct _seginfo segData [16];

struct _reg_struct	reg;

void
main ()
{
	pid_t	currentPID;

	currentPID = 1;
	for (;;) {
		currentPID = qnx_psinfo (PROC_PID, currentPID, &psData, 0, NULL);
		if (currentPID == -1) {
			if (errno == ESRCH || errno == EINVAL) {
				return;				/* done, go away */
			}
		}
		if ((psData.flags & (_PPF_MID | _PPF_VID)) == 0) {
			if (__qnx_debug_xfer(PROC_PID, currentPID, _DEBUG_REG_RD, &reg, sizeof(reg), 0, 0) != -1)
				printf("%20.20s %4.4lx:%4.4lx %4.4lx:%4.4lx %4.4lx %4.4lx %4.4lx %4.4lx %4.4lx %4.4lx %4.4lx %4.4lx %4.4lx %4.4lx\n",
				psData.un.proc.name,
				reg.cs, reg.ip, reg.ss, reg.sp, reg.ds, reg.es,
				reg.ax, reg.bx, reg.cx, reg.dx, reg.si, reg.di, reg.bp, reg.fl);
			else
				printf("%-69s", "Not available.");
		}
		currentPID++;
	}
}
