
/*
 *	USE.C
 *
 *	QNX
 *
 *	(C) Copyright 1991, 1992 by Robert Krten, all rights reserved.
 *
 *	This module contains the usage message for QNX 4 SYSMON.
 *
 *	1991 09 21	R. Krten		created
 *	1992 01 05	R. Krten		released for free
 *	1992 04 18	R. Krten		added "status"
 *	1996 08 19	R. Krten		added interrupts/faults/kcalls
*/

#ifdef __USAGE
%C	[options]

Where [options] can be:

    m=<monitorType>

        Where <monitorType> can be one of:

            interrupts    will display interrupts per sample period
            faults        will display faults per sample period
            kcalls        will display kernel calls per sample period
            physmem       will display a map of the physical memory usage
            register      will display the process registers
            states        will display QNX process states
            status        will display status summary of current procs
            topcode       will monitor the top code using processes
            topcpu        will monitor the top CPU time processes
            topmem        will monitor the top memory using processes
            topdata       will monitor the top data using processes

        <monitorType> defaults to "topcpu".

    +histogram

        Displays a histogram on the lower portion of the screen showing the
        current parameter set over a longer period of time.  Requires more
        than 25 lines of display.  Note that for m=topcpu, only processes
        with a priority greater than 1 will count.  Note further that this
        feature only works with some m= types.

    a=<attribute>

        Defines the terminal colour attributes (default to current).

    i=<interval>

        Defines the sampling period.  Floating point number, in seconds.

Once in monitor mode, hitting "q<Return>" will exit.

#endif
